(function () {
    "use strict";

    angular.module('pos').controller('relatorioPagamentoPorAdmCartaoController', controller);
    controller.$inject = ['$scope', '$window', '$state', '$filter', 'relatorioService', '$timeout'];

    function controller($scope, $window, $state, $filter, relatorioService, $timeout) {
        $scope.$parent.initializeLayout('Relatório');

        $scope.printPdf = function (showDetails) {
            $timeout(function () {
                window.print();
            }, 2000);
        };

        $scope.state = {
            pagamentos: {
                chart: { data: [], carregando: false, vazio: true },
                report: { data: [], carregando: false, vazio: true },
                filtro: {},
            },
            showData: [],
            init: true,
            restricoes: false,
        }

        $scope.initialize = function () {
            setRestricoesRelatorio();
            $scope.clearFilter();
            //$scope.setTerminal();
            $scope.refresh();
        };

        var setRestricoesRelatorio = function () {
            var state = $state.current.name;

            if (state == "state-pagamento-por-adm-de-cartao")
                $scope.state.restricoes = true;
        }

        var validaData = function (data) {
            if (!data)
                return true;
            var hoje = new Date((new Date()).setHours(0, 0, 0, 0));
            var dias = dateDiferencaEmDias(data, hoje);
            return dias <= 30;
        }

        var dateDiferencaEmDias = function (a, b) {
            // Descartando timezone e horário de verão
            var utc1 = Date.UTC(a.getFullYear(), a.getMonth(), a.getDate());
            var utc2 = Date.UTC(b.getFullYear(), b.getMonth(), b.getDate());

            return Math.floor((utc2 - utc1) / (1000 * 60 * 60 * 24));
        }

        function getDateWithoutTime(date) {
            var dateObj = new Date(date);
            var dateWithoutTime = dateObj.toLocaleDateString();

            return dateWithoutTime;
        }


        $scope.changeStatus = function (i) {
            $scope.state.showData[i] = !$scope.state.showData[i];
            $scope.state.init = false;
        };

        $scope.setTerminal = function () {
            $scope.state.pagamentos.filtro.codigoTerminal = $scope.$parent.config.Terminal.Codigo;
        };

        $scope.historyBack = function () {
            $window.history.back();
        };

        $scope.chartTicketByAdministradoraCartao = function () {
            $scope.state.pagamentos.chart.carregando = true;
            $scope.state.pagamentos.chart.vazio = false;
            relatorioService
                .chartTicketByAdministradoraCartao($scope.state.pagamentos.filtro)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.$parent.toastr.error(response.Message, 'Carregando gráfico');
                            console.error(response.Exception);
                        }
                        else {
                            angular.copy(angular.fromJson(response.Data), $scope.state.pagamentos.chart.data);
                            $scope.state.pagamentos.chart.vazio = $scope.$parent.tools.buildChart('#chart-pagamento', '', response.Data, true);
                        }
                        $scope.state.pagamentos.chart.carregando = false;
                    },
                    function (error) {
                        $scope.$parent.toastr.error('Ao carregar o gráfico.', 'Comunicação com o servidor');
                        console.error(error);
                        $scope.state.pagamentos.chart.carregando = false;
                    }
                );
        };
        $scope.getTicketByAdministradoraCartao = function () {
            $scope.state.pagamentos.report.carregando = true;
            $scope.state.pagamentos.report.vazio = false;
            relatorioService
                .getPagamentosCartao($scope.state.pagamentos.filtro)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.$parent.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        }
                        else {
                            angular.copy(angular.fromJson(response.Data), $scope.state.pagamentos.report.data);
                            $scope.state.pagamentos.report.vazio = (!response.Data || response.Data.length == 0);
                        }
                        $scope.state.pagamentos.report.carregando = false;
                    },
                    function (error) {
                        $scope.$parent.toastr.error('Ao carregar o gráfico.', 'Comunicação com o servidor');
                        console.error(error);
                        $scope.state.pagamentos.report.carregando = false;
                    }
                );
        };
        $scope.getSum = function (data) {
            var sum = 0;
            for (var i = 0; i < data.length; i++)
                sum += data[i].Valor;
            return sum;
        }

        $scope.toggleFilter = function () {
            $scope.state.pagamentos.filtro.ativo = !$scope.state.pagamentos.filtro.ativo;
        };
        $scope.clearFilter = function () {
            $scope.state.pagamentos.filtro = {
                emissao: {
                    de: new Date((new Date()).setHours(0, 0, 0, 0)),
                    ate: null
                },
                codigoTerminal: '',
                periodoFechamento: '',
                codigoVendedor: '',
                ativo: false,
            }

        };

        $scope.refresh = function () {
            if ($scope.state.restricoes && (!validaData($scope.state.pagamentos.filtro.emissao.de) || !validaData($scope.state.pagamentos.filtro.emissao.ate))) {
                $scope.$parent.toastr.error('Escolha um intervalo de datas que não exceda os últimos 30 dias.');
                return;
            }
            $scope.state.pagamentos.filtro.restricoes = $scope.state.restricoes;

            //if ($scope.state.pagamentos.filtro.emissao.de) {
            //    var emissaoDe = $scope.state.pagamentos.filtro.emissao.de;
            //    var emissaoDeNoTime = getDateWithoutTime(emissaoDe);
            //    $scope.state.pagamentos.filtro.emissao.de = emissaoDeNoTime;
            //}

            //if ($scope.state.pagamentos.filtro.emissao.ate) {
            //    var emissaoAte = $scope.state.pagamentos.filtro.emissao.ate;
            //    var emissaoAteNoTime = getDateWithoutTime(emissaoAte);
            //    $scope.state.pagamentos.filtro.emissao.ate = emissaoAteNoTime;
            //}

            $scope.chartTicketByAdministradoraCartao($scope.state.pagamentos.filtro);
            $scope.getTicketByAdministradoraCartao($scope.state.pagamentos.filtro);
        };

        $scope.initialize();

    }

})();